{ stdenv, fetchurl, zstd, aarch64-image }:

stdenv.mkDerivation {
  name = "aarch64-image";
  src = aarch64-image;
  preferLocalBuild = true;
  dontUnpack = true;
  dontBuild = true;
  dontConfigure = true;

  # Performance
  dontPatchELF = true;
  dontStrip = true;
  noAuditTmpdir = true;
  dontPatchShebangs = true;

  nativeBuildInputs = [
    zstd
  ];

  installPhase = ''
    zstdcat "$src" > $out
  '';
}
